package file.sr;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class ArrayDePacotes {

	File file;
	FileInputStream fis;
	BufferedInputStream bis;

	int numberOfPackets;
	int lastPacketSize;
	int tamanhoArquivo;
	int packetNumber;
	public final double DATAPACKET_SIZE = 5000;

	public Pacote[] arrayDePacotes;

	public int actualPacket = 0;

	public ArrayDePacotes(String fileName) throws IOException {
		file = new File(fileName);
		fis = new FileInputStream(file);
		bis = new BufferedInputStream(fis);
		numberOfPackets = (int) Math.ceil(file.length() / DATAPACKET_SIZE);
		lastPacketSize = (int) (file.length() - (numberOfPackets - 1)
				* DATAPACKET_SIZE);
		tamanhoArquivo = (int) file.length();
		arrayDePacotes = new Pacote[100];
	}

	public void criarArray() throws IOException {
		for (int i = 0; i < numberOfPackets; i++) {
			packetNumber = i;
			if (i == numberOfPackets - 1) {
				Pacote novo = new Pacote(packetNumber, (byte) 1,
						lastPacketSize, bis);
				arrayDePacotes[i] = novo;

			} else {
				Pacote novo = new Pacote(packetNumber, (byte) 0,
						lastPacketSize, bis);
				arrayDePacotes[i] = novo;

			}
		}
		bis.close();
		fis.close();

	}

	public void atualizarPrimeiraMetade() throws IOException {

		for (int i = 0; i < 50; i++) {

			if (actualPacket == numberOfPackets - 1) {
				Pacote novo = new Pacote(actualPacket, (byte) 1,
						lastPacketSize, bis);
				arrayDePacotes[i] = novo;
				actualPacket++;

			} else {
				Pacote novo = new Pacote(actualPacket, (byte) 0,
						lastPacketSize, bis);
				arrayDePacotes[i] = novo;
				actualPacket++;

			}
		}
	}

	public void atualizarSegundaMetade() throws IOException {
		for (int i = 50; i < 100; i++) {

			if (actualPacket == numberOfPackets - 1) {
				Pacote novo = new Pacote(actualPacket, (byte) 1,
						lastPacketSize, bis);
				arrayDePacotes[i] = novo;
				actualPacket++;

			} else {
				Pacote novo = new Pacote(actualPacket, (byte) 0,
						lastPacketSize, bis);
				arrayDePacotes[i] = novo;
				actualPacket++;

			}
		}
	}

}
