package client;

import java.io.IOException;
import java.util.TimerTask;

import net.ConnectionInfo;
import net.TimeoutLimitException;

public class FachadaTask extends TimerTask{
	private FachadaClient fachada;
	private ConnectionInfo ci;
	private String path;
	private ClientGuiListener listener;
	public FachadaTask(FachadaClient fachada, ConnectionInfo ci, String path, ClientGuiListener listener){
		this.fachada = fachada;
		this.ci = ci;
		this.path = path;
		this.listener = listener;
	}
	@Override
	public void run() {
		try {
			fachada.mandarArquivo(ci, path);
		} catch (IOException e) {
			listener.error(e);
		} catch (TimeoutLimitException e) {
			listener.error(e);

		} catch (UsuarioNegouException e) {
			listener.error(e);

		} catch (InterruptedException e) {
			listener.error(e);
		}
	}
	

}
